searchNodes=[{"doc":"Converts HTML to Temple syntax Takes HTML from a file or from stdin and outputs temple syntax to stdout.","ref":"Mix.Tasks.Temple.Convert.html","title":"Mix.Tasks.Temple.Convert","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Temple.Convert.html#run/1","title":"Mix.Tasks.Temple.Convert.run/1","type":"function"},{"doc":"Generates controller, views, and context for an HTML resource in Temple. mix temple.gen.html Accounts User users name:string age:integer The first argument is the context module followed by the schema module and its plural name (used as the schema table name). The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource. Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User). The schema is responsible for mapping the database fields into an Elixir struct. Overall, this generator will add the following files to lib/: a context module in lib/app/accounts.ex for the accounts API a schema in lib/app/accounts/user.ex, with an users table a view in lib/app_web/views/user_view.ex a controller in lib/app_web/controllers/user_controller.ex default CRUD templates in lib/app_web/templates/user A migration file for the repository and test files for the context and controller features will also be generated. The location of the web files (controllers, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration: config :my_app_web, :generators, context_app: :my_app Alternatively, the --context-app option may be supplied to the generator: mix phx.gen.html Sales User users --context-app warehouse Web namespace By default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example: mix phx.gen.html.temple Sales User users --web Sales Which would generate a lib/app_web/controllers/sales/user_controller.ex and lib/app_web/views/sales/user_view.ex. Generating without a schema or context file In some cases, you may wish to bootstrap HTML templates, controllers, and controller tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix phx.gen.html.temple Accounts User users --table cms_users binary_id Generated migration can use binary_id for schema&#39;s primary key and its references with option --binary-id. Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app, :generators, migration: true, binary_id: false, sample_binary_id: &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration. Read the documentation for phx.gen.schema for more information on attributes.","ref":"Mix.Tasks.Temple.Gen.Html.html","title":"Mix.Tasks.Temple.Gen.Html","type":"task"},{"doc":"Generates a Phoenix layout file in Temple. mix temple.gen.layout","ref":"Mix.Tasks.Temple.Gen.Layout.html","title":"Mix.Tasks.Temple.Gen.Layout","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Temple.Gen.Layout.html#run/1","title":"Mix.Tasks.Temple.Gen.Layout.run/1","type":"function"},{"doc":"","ref":"Temple.html","title":"Temple","type":"module"},{"doc":"Defines a custom component. Components are the primary way to extract partials and markup helpers. Assigns Components accept a keyword list or a map of assigns and can be referenced in the body of the component by a module attribute of the same name. This works exactly the same as EEx templates. The whole list or map of assigns can be accessed by a special assign called @assigns. Children If a block is passed to the component, it can be referenced by a special assign called @children. Example defcomponent :flex do div id: @id, class: &quot;flex&quot; do @children end end temple do flex id: &quot;my-flex&quot; do div &quot;Item 1&quot; div &quot;Item 2&quot; div &quot;Item 3&quot; end end # {:safe, &quot;&lt;div id=&quot;my-flex&quot; class=&quot;flex&quot;&gt; # &lt;div&gt;Item 1&lt;/div&gt; # &lt;div&gt;Item 2&lt;/div&gt; # &lt;div&gt;Item 3&lt;/div&gt; # &lt;/div&gt;&quot;}","ref":"Temple.html#defcomponent/2","title":"Temple.defcomponent/2","type":"macro"},{"doc":"Emits a Phoenix partial into the markup. temple do html lang: &quot;en&quot; do head do title &quot;MyApp&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do main role: &quot;main&quot;, class: &quot;container&quot; do p get_flash(@conn, :info), class: &quot;alert alert-info&quot;, role: &quot;alert&quot; p get_flash(@conn, :error), class: &quot;alert alert-danger&quot;, role: &quot;alert&quot; partial render(@view_module, @view_template, assigns) end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end end end","ref":"Temple.html#partial/1","title":"Temple.partial/1","type":"macro"},{"doc":"Creates a markup context. All tags must be called inside of a Temple.temple/1 block. Returns a safe result of the form {:safe, result} Example team = [&quot;Alice&quot;, &quot;Bob&quot;, &quot;Carol&quot;] temple do for name &lt;- team do div class: &quot;text-bold&quot; do text name end end end # {:safe, &quot;&lt;div class=&quot;text-bold&quot;&gt;Alice&lt;/div&gt;&lt;div class=&quot;text-bold&quot;&gt;Bob&lt;/div&gt;&lt;div class=&quot;text-bold&quot;&gt;Carol&lt;/div&gt;&quot;}","ref":"Temple.html#temple/1","title":"Temple.temple/1","type":"macro"},{"doc":"Emits a text node into the markup. temple do div do text &quot;Hello, world!&quot; end end # {:safe, &quot;&lt;div&gt;Hello, world!&lt;/div&gt;&quot;}","ref":"Temple.html#text/1","title":"Temple.text/1","type":"macro"},{"doc":"This module contains the primitives used to generate the macros in the Temple.Html and Temple.Svg modules.","ref":"Temple.Elements.html","title":"Temple.Elements","type":"module"},{"doc":"Defines an element. Note: Underscores are converted to dashes. defmodule MyElements do import Temple.Elements defelement :super_select, :nonvoid # &lt;super-select&gt;&lt;/super-select&gt; defelement :super_input, :void # &lt;super-input&gt; end","ref":"Temple.Elements.html#defelement/2","title":"Temple.Elements.defelement/2","type":"macro"},{"doc":"Temple provides a templating engine for use in Phoenix web applications. You can configure your application to use Temple templates by adding the following configuration. # config.exs config :phoenix, :template_engines, exs: Temple.Engine # config/dev.exs config :your_app, YourAppWeb.Endpoint, live_reload: [ patterns: [ ~r&quot;lib/your_app_web/templates/.*(exs)$&quot; ] ] # your_app_web.ex def view do quote location: :keep do # ... use Temple # Replaces the call to import Phoenix.HTML end end Usage Temple templates use the .exs extension, because they are written with pure Elixir! assigns (@conn, etc) are handled the same as normal Phoenix.HTML.Engine templates. Note: The Temple.temple/1 macro is not needed for Temple templates due to the engine taking care of that for you. # app.html.exs html lang: &quot;en&quot; do head do meta charset: &quot;utf-8&quot; meta http_equiv: &quot;X-UA-Compatible&quot;, content: &quot;IE=edge&quot; meta name: &quot;viewport&quot;, content: &quot;width=device-width, initial-scale=1.0&quot; title &quot;YourApp · Phoenix Framework&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do header do section class: &quot;container&quot; do nav role: &quot;navigation&quot; do ul do li do: a(&quot;Get Started&quot;, href: &quot;https://hexdocs.pm/phoenix/overview.html&quot;) end end a href: &quot;http://phoenixframework.org/&quot;, class: &quot;phx-logo&quot; do img src: Routes.static_path(@conn, &quot;/images/phoenix.png&quot;), alt: &quot;Phoenix Framework Logo&quot; end end end main role: &quot;main&quot;, class: &quot;container&quot; do p get_flash(@conn, :info), class: &quot;alert alert-info&quot;, role: &quot;alert&quot; p get_flash(@conn, :error), class: &quot;alert alert-danger&quot;, role: &quot;alert&quot; partial render(@view_module, @view_template, assigns) end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end end","ref":"Temple.Engine.html","title":"Temple.Engine","type":"module"},{"doc":"Callback implementation for Phoenix.Template.Engine.compile/2.","ref":"Temple.Engine.html#compile/2","title":"Temple.Engine.compile/2","type":"function"},{"doc":"This modules wraps all of the functions from the Phoenix.HTML.Form module to make them compatible with with Temple.","ref":"Temple.Form.html","title":"Temple.Form","type":"module"},{"doc":"Please see Phoenix.HTML.Form.checkbox/3 for details.","ref":"Temple.Form.html#checkbox/3","title":"Temple.Form.checkbox/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.color_input/3 for details.","ref":"Temple.Form.html#color_input/3","title":"Temple.Form.color_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.date_input/3 for details.","ref":"Temple.Form.html#date_input/3","title":"Temple.Form.date_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.date_select/3 for details.","ref":"Temple.Form.html#date_select/3","title":"Temple.Form.date_select/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.datetime_local_input/3 for details.","ref":"Temple.Form.html#datetime_local_input/3","title":"Temple.Form.datetime_local_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.datetime_select/3 for details.","ref":"Temple.Form.html#datetime_select/3","title":"Temple.Form.datetime_select/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.email_input/3 for details.","ref":"Temple.Form.html#email_input/3","title":"Temple.Form.email_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.file_input/3 for details.","ref":"Temple.Form.html#file_input/3","title":"Temple.Form.file_input/3","type":"macro"},{"doc":"Generates an empty form tag. See Temple.Form.form_for/4 for more details","ref":"Temple.Form.html#form_for/2","title":"Temple.Form.form_for/2","type":"macro"},{"doc":"Generates a form tag with a form builder and a block. The form builder will be available inside the block through the form variable. This is a wrapper around the Phoenix.HTML.Form.form_for/4 function and accepts all of the same options. Example temple do form_for @conn, Routes.some_path(@conn, :create) do text_input form, :name end end # {:safe, # &quot;&lt;form accept-charset=&quot;UTF-8&quot; action=&quot;/&quot; method=&quot;post&quot;&gt; # &lt;input name=&quot;_csrf_token&quot; type=&quot;hidden&quot; value=&quot;AS5qfX1gcns6eU56BlQgBlwCDgMlNgAAiJ0MR91Kh3v3bbCS5SKjuw==&quot;&gt; # &lt;input name=&quot;_utf8&quot; type=&quot;hidden&quot; value=&quot;✓&quot;&gt; # &lt;input id=&quot;name&quot; name=&quot;name&quot; type=&quot;text&quot;&gt; # &lt;/form&gt;&quot;}","ref":"Temple.Form.html#form_for/4","title":"Temple.Form.form_for/4","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.hidden_input/3 for details.","ref":"Temple.Form.html#hidden_input/3","title":"Temple.Form.hidden_input/3","type":"macro"},{"doc":"Generate a new form builder for the given parameter in form. The form builder will be available inside the block through the inner_form variable. This is a wrapper around the Phoenix.HTML.Form.inputs_for/4 function and accepts all of the same options. Example temple do form_for @parent, Routes.some_path(@conn, :create) do text_input form, :name inputs_for form, :job do text_input inner_form, :description end inputs_for form, :children do text_input inner_form, :name end end end # {:safe, # &quot;&lt;form accept-charset=&quot;UTF-8&quot; action=&quot;/&quot; method=&quot;post&quot;&gt; # &lt;input name=&quot;_csrf_token&quot; type=&quot;hidden&quot; value=&quot;AS5qfX1gcns6eU56BlQgBlwCDgMlNgAAiJ0MR91Kh3v3bbCS5SKjuw==&quot;&gt; # &lt;input name=&quot;_utf8&quot; type=&quot;hidden&quot; value=&quot;✓&quot;&gt; # &lt;input id=&quot;name&quot; name=&quot;parent[name]&quot; type=&quot;text&quot;&gt; # # &lt;input id=&quot;name&quot; name=&quot;parent[job][description]&quot; type=&quot;text&quot;&gt; # # &lt;input id=&quot;name&quot; name=&quot;parent[children][1][name]&quot; type=&quot;text&quot;&gt; # &lt;input id=&quot;name&quot; name=&quot;parent[children][2][name]&quot; type=&quot;text&quot;&gt; # &lt;/form&gt;&quot;}","ref":"Temple.Form.html#inputs_for/4","title":"Temple.Form.inputs_for/4","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.multiple_select/4 for details.","ref":"Temple.Form.html#multiple_select/4","title":"Temple.Form.multiple_select/4","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.number_input/3 for details.","ref":"Temple.Form.html#number_input/3","title":"Temple.Form.number_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.password_input/3 for details.","ref":"Temple.Form.html#password_input/3","title":"Temple.Form.password_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.label/2 for details.","ref":"Temple.Form.html#phx_label/2","title":"Temple.Form.phx_label/2","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.label/3 for details.","ref":"Temple.Form.html#phx_label/3","title":"Temple.Form.phx_label/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.label/4 for details.","ref":"Temple.Form.html#phx_label/4","title":"Temple.Form.phx_label/4","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.radio_button/4 for details.","ref":"Temple.Form.html#radio_button/4","title":"Temple.Form.radio_button/4","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.range_input/3 for details.","ref":"Temple.Form.html#range_input/3","title":"Temple.Form.range_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.reset/2 for details.","ref":"Temple.Form.html#reset/2","title":"Temple.Form.reset/2","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.search_input/3 for details.","ref":"Temple.Form.html#search_input/3","title":"Temple.Form.search_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.select/4 for details.","ref":"Temple.Form.html#select/4","title":"Temple.Form.select/4","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.submit/1 for details.","ref":"Temple.Form.html#submit/1","title":"Temple.Form.submit/1","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.submit/1 for details.","ref":"Temple.Form.html#submit/2","title":"Temple.Form.submit/2","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.telephone_input/3 for details.","ref":"Temple.Form.html#telephone_input/3","title":"Temple.Form.telephone_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.textarea/3 for details. Note: Temple defines this function as text_area with an underscore, whereas Phoenix.HTML defines it as textarea without an underscore.","ref":"Temple.Form.html#text_area/3","title":"Temple.Form.text_area/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.text_input/3 for details.","ref":"Temple.Form.html#text_input/3","title":"Temple.Form.text_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.time_input/3 for details.","ref":"Temple.Form.html#time_input/3","title":"Temple.Form.time_input/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.time_select/3 for details.","ref":"Temple.Form.html#time_select/3","title":"Temple.Form.time_select/3","type":"macro"},{"doc":"Please see Phoenix.HTML.Form.url_input/3 for details.","ref":"Temple.Form.html#url_input/3","title":"Temple.Form.url_input/3","type":"macro"},{"doc":"The Temple.Html module defines macros for all HTML5 compliant elements. Temple.Html macros must be called inside of a Temple.temple/1 block. Note: Only the lowest arity macros are documented. Void elements are defined as a 1-arity macro and non-void elements are defined as 0, 1, and 2-arity macros. Attributes Html accept a keyword list or a map of attributes to be emitted into the element&#39;s opening tag. Multi-word attribute keys written in snake_case (data_url) will be transformed into kebab-case (data-url). Children Non-void elements (such as div) accept a block that can be used to nest other tags or text nodes. These blocks can contain arbitrary Elixir code such as variables and for comprehensions. If you are only emitting a text node within a block, you can use the shortened syntax by passing the text in as the first parameter of the tag. Example temple do # empty non-void element div() # non-void element with keyword list attributes div class: &quot;text-red&quot;, id: &quot;my-el&quot; # non-void element with map attributes div %{:class =&gt; &quot;text-red&quot;, &quot;id&quot; =&gt; &quot;my-el&quot;} # non-void element with children div do text &quot;Hello, world!&quot; for name &lt;- @names do div data_name: name end end # non-void element with a single text node div &quot;Hello, world!&quot;, class: &quot;text-green&quot; # void elements input name: &quot;comments&quot;, placeholder: &quot;Enter a comment...&quot; end # {:safe, # &quot;&lt;div&gt;&lt;/div&gt; # &lt;div class=&quot;text-red&quot; id=&quot;my-el&quot;&gt;&lt;/div&gt; # &lt;div&gt; # Hello, world! # &lt;div data-name=&quot;Alice&quot;&gt;&lt;/div&gt; # &lt;div data-name=&quot;Bob&quot;&gt;&lt;/div&gt; # &lt;div data-name=&quot;Carol&quot;&gt;&lt;/div&gt; # &lt;/div&gt; # &lt;div class=&quot;text-green&quot;&gt;Hello, world!&lt;/div&gt; # &lt;input name=&quot;comments&quot; placeholder=&quot;Enter a comment...&quot;&gt;&quot; # }","ref":"Temple.Html.html","title":"Temple.Html","type":"module"},{"doc":"","ref":"Temple.Html.html#a/0","title":"Temple.Html.a/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#abbr/0","title":"Temple.Html.abbr/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#address/0","title":"Temple.Html.address/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#area/1","title":"Temple.Html.area/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#article/0","title":"Temple.Html.article/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#aside/0","title":"Temple.Html.aside/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#audio/0","title":"Temple.Html.audio/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#b/0","title":"Temple.Html.b/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#base/1","title":"Temple.Html.base/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#bdi/0","title":"Temple.Html.bdi/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#bdo/0","title":"Temple.Html.bdo/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#blockquote/0","title":"Temple.Html.blockquote/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#body/0","title":"Temple.Html.body/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#br/1","title":"Temple.Html.br/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#button/0","title":"Temple.Html.button/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#canvas/0","title":"Temple.Html.canvas/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#caption/0","title":"Temple.Html.caption/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#cite/0","title":"Temple.Html.cite/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#code/0","title":"Temple.Html.code/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#col/1","title":"Temple.Html.col/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#colgroup/0","title":"Temple.Html.colgroup/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#data/0","title":"Temple.Html.data/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#datalist/0","title":"Temple.Html.datalist/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#dd/0","title":"Temple.Html.dd/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#del/0","title":"Temple.Html.del/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#details/0","title":"Temple.Html.details/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#dfn/0","title":"Temple.Html.dfn/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#div/0","title":"Temple.Html.div/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#dl/0","title":"Temple.Html.dl/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#dt/0","title":"Temple.Html.dt/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#em/0","title":"Temple.Html.em/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#embed/1","title":"Temple.Html.embed/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#fieldset/0","title":"Temple.Html.fieldset/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#figcaption/0","title":"Temple.Html.figcaption/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#figure/0","title":"Temple.Html.figure/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#footer/0","title":"Temple.Html.footer/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#form/0","title":"Temple.Html.form/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#h1/0","title":"Temple.Html.h1/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#h2/0","title":"Temple.Html.h2/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#h3/0","title":"Temple.Html.h3/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#h4/0","title":"Temple.Html.h4/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#h5/0","title":"Temple.Html.h5/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#h6/0","title":"Temple.Html.h6/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#head/0","title":"Temple.Html.head/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#header/0","title":"Temple.Html.header/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#hr/1","title":"Temple.Html.hr/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#html/2","title":"Temple.Html.html/2","type":"macro"},{"doc":"","ref":"Temple.Html.html#i/0","title":"Temple.Html.i/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#iframe/0","title":"Temple.Html.iframe/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#img/1","title":"Temple.Html.img/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#input/1","title":"Temple.Html.input/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#ins/0","title":"Temple.Html.ins/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#kbd/0","title":"Temple.Html.kbd/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#keygen/1","title":"Temple.Html.keygen/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#label/0","title":"Temple.Html.label/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#legend/0","title":"Temple.Html.legend/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#li/0","title":"Temple.Html.li/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#link/1","title":"Temple.Html.link/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#main/0","title":"Temple.Html.main/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#map/0","title":"Temple.Html.map/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#mark/0","title":"Temple.Html.mark/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#menu/0","title":"Temple.Html.menu/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#menuitem/0","title":"Temple.Html.menuitem/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#meta/1","title":"Temple.Html.meta/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#meter/0","title":"Temple.Html.meter/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#nav/0","title":"Temple.Html.nav/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#noscript/0","title":"Temple.Html.noscript/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#object/0","title":"Temple.Html.object/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#ol/0","title":"Temple.Html.ol/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#optgroup/0","title":"Temple.Html.optgroup/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#option/0","title":"Temple.Html.option/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#output/0","title":"Temple.Html.output/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#p/0","title":"Temple.Html.p/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#param/1","title":"Temple.Html.param/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#pre/0","title":"Temple.Html.pre/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#progress/0","title":"Temple.Html.progress/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#q/0","title":"Temple.Html.q/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#rp/0","title":"Temple.Html.rp/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#rt/0","title":"Temple.Html.rt/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#ruby/0","title":"Temple.Html.ruby/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#s/0","title":"Temple.Html.s/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#samp/0","title":"Temple.Html.samp/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#script/0","title":"Temple.Html.script/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#section/0","title":"Temple.Html.section/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#select/0","title":"Temple.Html.select/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#small/0","title":"Temple.Html.small/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#source/1","title":"Temple.Html.source/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#span/0","title":"Temple.Html.span/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#strong/0","title":"Temple.Html.strong/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#style/0","title":"Temple.Html.style/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#sub/0","title":"Temple.Html.sub/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#summary/0","title":"Temple.Html.summary/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#sup/0","title":"Temple.Html.sup/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#table/0","title":"Temple.Html.table/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#tbody/0","title":"Temple.Html.tbody/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#td/0","title":"Temple.Html.td/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#template/0","title":"Temple.Html.template/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#textarea/0","title":"Temple.Html.textarea/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#tfoot/0","title":"Temple.Html.tfoot/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#th/0","title":"Temple.Html.th/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#thead/0","title":"Temple.Html.thead/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#time/0","title":"Temple.Html.time/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#title/0","title":"Temple.Html.title/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#tr/0","title":"Temple.Html.tr/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#track/1","title":"Temple.Html.track/1","type":"macro"},{"doc":"","ref":"Temple.Html.html#u/0","title":"Temple.Html.u/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#ul/0","title":"Temple.Html.ul/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#var/0","title":"Temple.Html.var/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#video/0","title":"Temple.Html.video/0","type":"macro"},{"doc":"","ref":"Temple.Html.html#wbr/1","title":"Temple.Html.wbr/1","type":"macro"},{"doc":"This modules wraps all of the functions from the Phoenix.HTML.Link module to make them compatible with with Temple.","ref":"Temple.Link.html","title":"Temple.Link","type":"module"},{"doc":"Please see Phoenix.HTML.Link.button/2 for details.","ref":"Temple.Link.html#phx_button/2","title":"Temple.Link.phx_button/2","type":"macro"},{"doc":"Please see Phoenix.HTML.Link.link/2 for details.","ref":"Temple.Link.html#phx_link/2","title":"Temple.Link.phx_link/2","type":"macro"},{"doc":"The Temple.Svg module defines macros for all SVG elements. Usage is the same as Temple.Html.","ref":"Temple.Svg.html","title":"Temple.Svg","type":"module"},{"doc":"","ref":"Temple.Svg.html#animate/0","title":"Temple.Svg.animate/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#animateMotion/0","title":"Temple.Svg.animateMotion/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#animateTransform/0","title":"Temple.Svg.animateTransform/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#circle/0","title":"Temple.Svg.circle/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#clipPath/0","title":"Temple.Svg.clipPath/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#color_profile/0","title":"Temple.Svg.color_profile/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#defs/0","title":"Temple.Svg.defs/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#desc/0","title":"Temple.Svg.desc/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#discard/0","title":"Temple.Svg.discard/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#ellipse/0","title":"Temple.Svg.ellipse/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feBlend/0","title":"Temple.Svg.feBlend/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feColorMatrix/0","title":"Temple.Svg.feColorMatrix/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feComponentTransfer/0","title":"Temple.Svg.feComponentTransfer/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feComposite/0","title":"Temple.Svg.feComposite/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feConvolveMatrix/0","title":"Temple.Svg.feConvolveMatrix/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feDiffuseLighting/0","title":"Temple.Svg.feDiffuseLighting/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feDisplacementMap/0","title":"Temple.Svg.feDisplacementMap/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feDistantLight/0","title":"Temple.Svg.feDistantLight/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feDropShadow/0","title":"Temple.Svg.feDropShadow/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feFlood/0","title":"Temple.Svg.feFlood/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feFuncA/0","title":"Temple.Svg.feFuncA/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feFuncB/0","title":"Temple.Svg.feFuncB/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feFuncG/0","title":"Temple.Svg.feFuncG/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feFuncR/0","title":"Temple.Svg.feFuncR/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feGaussianBlur/0","title":"Temple.Svg.feGaussianBlur/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feImage/0","title":"Temple.Svg.feImage/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feMerge/0","title":"Temple.Svg.feMerge/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feMergeNode/0","title":"Temple.Svg.feMergeNode/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feMorphology/0","title":"Temple.Svg.feMorphology/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feOffset/0","title":"Temple.Svg.feOffset/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#fePointLight/0","title":"Temple.Svg.fePointLight/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feSpecularLighting/0","title":"Temple.Svg.feSpecularLighting/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feSpotLight/0","title":"Temple.Svg.feSpotLight/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feTile/0","title":"Temple.Svg.feTile/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#feTurbulence/0","title":"Temple.Svg.feTurbulence/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#filter/0","title":"Temple.Svg.filter/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#foreignObject/0","title":"Temple.Svg.foreignObject/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#g/0","title":"Temple.Svg.g/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#hatch/0","title":"Temple.Svg.hatch/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#hatchpath/0","title":"Temple.Svg.hatchpath/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#image/0","title":"Temple.Svg.image/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#line/0","title":"Temple.Svg.line/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#linearGradient/0","title":"Temple.Svg.linearGradient/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#marker/0","title":"Temple.Svg.marker/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#mask/0","title":"Temple.Svg.mask/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#metadata/0","title":"Temple.Svg.metadata/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#mpath/0","title":"Temple.Svg.mpath/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#path/0","title":"Temple.Svg.path/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#pattern/0","title":"Temple.Svg.pattern/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#polygon/0","title":"Temple.Svg.polygon/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#polyline/0","title":"Temple.Svg.polyline/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#radialGradient/0","title":"Temple.Svg.radialGradient/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#rect/0","title":"Temple.Svg.rect/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#set/0","title":"Temple.Svg.set/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#solidcolor/0","title":"Temple.Svg.solidcolor/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#stop/0","title":"Temple.Svg.stop/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#svg/0","title":"Temple.Svg.svg/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#switch/0","title":"Temple.Svg.switch/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#symbol/0","title":"Temple.Svg.symbol/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#textPath/0","title":"Temple.Svg.textPath/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#text_/0","title":"Temple.Svg.text_/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#tspan/0","title":"Temple.Svg.tspan/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#use/0","title":"Temple.Svg.use/0","type":"macro"},{"doc":"","ref":"Temple.Svg.html#view/0","title":"Temple.Svg.view/0","type":"macro"},{"doc":"Temple is a DSL for writing HTML using Elixir. You&#39;re probably here because you want to use Temple to write Phoenix templates, which is why Temple includes a Phoenix template engine and Temple-compatible Phoenix form helpers.","ref":"readme.html","title":"","type":"extras"},{"doc":"Add temple to your list of dependencies in mix.exs: def deps do [{:temple, &quot;~&gt; 0.4.0&quot;}] end","ref":"readme.html#installation","title":" - Installation","type":"extras"},{"doc":"Using Temple is a as simple as using the DSL inside of an temple/1 block. This returns a safe result of the form {:safe, html_string}. See the documentation for more details. use Temple temple do h2 &quot;todos&quot; ul class: &quot;list&quot; do for item &lt;- @items do li class: &quot;item&quot; do div class: &quot;checkbox&quot; do div class: &quot;bullet hidden&quot; end div item end end end script &quot;&quot;&quot; function toggleCheck({currentTarget}) { currentTarget.children[0].children[0].classList.toggle(&quot;hidden&quot;); } let items = document.querySelectorAll(&quot;li&quot;); Array.from(items).forEach(checkbox =&gt; checkbox.addEventListener(&quot;click&quot;, toggleCheck)); &quot;&quot;&quot; end Components Temple provides an API for creating custom components that act as custom HTML elements. These components can be given assigns that are available inside the component definition as module attributes. The contents of a components do block are available as a special @children assign. See the documentation for more details. defcomponent :flex do div id: @id, class: &quot;flex&quot; do @children end end temple do flex id: &quot;my-flex&quot; do div &quot;Item 1&quot; div &quot;Item 2&quot; div &quot;Item 3&quot; end end Phoenix.HTML Temple provides macros for working with the helpers provided by the Phoenix.HTML package. Most of the macros are purely wrappers, while the semantics of some are changed to work with Temple. See the documentation for more details. temple do form_for @conn, Routes.some_path(@conn, :create) do text_input form, :name end end Phoenix templates Add the templating engine to your Phoenix configuration. See the documentation for more details. # config.exs config :phoenix, :template_engines, exs: Temple.Engine # config/dev.exs config :your_app, YourAppWeb.Endpoint, live_reload: [ patterns: [ ~r&quot;lib/your_app_web/templates/.*(exs)$&quot; ] ] # your_app_web.ex def view do quote do # ... use Temple # Replaces the call to import Phoenix.HTML end end # app.html.exs html lang: &quot;en&quot; do head do meta charset: &quot;utf-8&quot; meta http_equiv: &quot;X-UA-Compatible&quot;, content: &quot;IE=edge&quot; meta name: &quot;viewport&quot;, content: &quot;width=device-width, initial-scale=1.0&quot; title &quot;YourApp · Phoenix Framework&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do header do section class: &quot;container&quot; do nav role: &quot;navigation&quot; do ul do li do: a(&quot;Get Started&quot;, href: &quot;https://hexdocs.pm/phoenix/overview.html&quot;) end end a href: &quot;http://phoenixframework.org/&quot;, class: &quot;phx-logo&quot; do img src: Routes.static_path(@conn, &quot;/images/phoenix.png&quot;), alt: &quot;Phoenix Framework Logo&quot; end end end main role: &quot;main&quot;, class: &quot;container&quot; do p get_flash(@conn, :info), class: &quot;alert alert-info&quot;, role: &quot;alert&quot; p get_flash(@conn, :error), class: &quot;alert alert-danger&quot;, role: &quot;alert&quot; partial render(@view_module, @view_template, assigns) end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end end Tasks temple.convert This task can be used to convert plain HTML and SVG into Temple syntax. Input is taken from stdin or from a file and the output is sent to stdout. cat index.html | mix temple.convert &gt; index.html.exs Formatter To include Temple&#39;s formatter configuration, add :temple to your .formatter.exs. [ import_deps: [:temple], inputs: [&quot;*.{ex,exs}&quot;, &quot;priv/*/seeds.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs}&quot;], ]","ref":"readme.html#usage","title":" - Usage","type":"extras"}]